﻿Module Module1

    Sub Main()
        Dim pathstyle As String
        pathstyle = "windows"

        For Each arg As String In My.Application.CommandLineArgs
            If arg = "--cygwin" Then
                pathstyle = "cygwin"
            End If

            If arg = "--help" Or arg = "--version" Or arg = "-h" Or arg = "-v" Or arg = "-?" Or arg = "--help" Or arg = "/?" Or arg = "-h" Or arg = "/h" Then
                Console.WriteLine("DesktopPath.exe by Eli Fulkerson, mostly from a stackoverflow post:")
                Console.WriteLine("http://stackoverflow.com/questions/2000638/whats-the-environment-variable-for-the-path-to-the-desktop")
                Console.WriteLine("I use it to hold my roving Cygwin thumbdrive together.  Can't always expect ")
                Console.WriteLine("powershell/whatever, so I compiled it real quick in VB")
                Console.WriteLine("")
                Console.WriteLine("Arguments:  --cygwin will attempt to create a cygwin style path, for instance:")
                Console.WriteLine("DesktopPath")
                Console.WriteLine("C:\Users\Eli\Desktop")
                Console.WriteLine("")
                Console.WriteLine("DesktopPath --cygwin")
                Console.WriteLine("/cygdrive/c/Users/Eli/Desktop")
                Console.WriteLine("")
                Console.WriteLine("Visit http://www.elifulkerson.com for updates (if available)")
                Environment.Exit(0)

            End If


        Next

        ' code from:
        ' http://stackoverflow.com/questions/2000638/whats-the-environment-variable-for-the-path-to-the-desktop

        Dim WSHShell, desktop, objFSO
        Dim pathstring As String
        objFSO = CreateObject("Scripting.FileSystemObject")
        WSHShell = CreateObject("WScript.Shell")
        desktop = WSHShell.SpecialFolders("Desktop")
        pathstring = objFSO.GetAbsolutePathName(desktop)

        If pathstyle = "windows" Then
            Console.Write(pathstring)
        End If

        If pathstyle = "cygwin" Then
            Console.Write("/cygdrive/" + pathstring.Substring(0, 1).ToLower() + "/" + pathstring.Substring(3, pathstring.Length - 3).Replace("\", "/"))
        End If


    End Sub

End Module
